import { ICodeResource } from '@cloudbase/cals';
import { LowcodeContext } from './parser/base';
export { generateStyleModuleMap } from './parser/lessParser';
export declare const lowcodeContext: LowcodeContext;
/**
 * Reexecute all low code when updated
 * 本函数重复执行时第一次执行会抛出 code:MODULE_REPEAT_CODE 的错误
 * 涉及重复请求时需要处理该错误
 */
export declare function generateLowcodeModules({ key, runtimeWindow, codeModulesMap, onDependencyMiss, dependencies, externals, context, }: {
    key: string;
    runtimeWindow: Window;
    codeModulesMap: {
        global?: ICodeResource[];
        [pageId: string]: ICodeResource[];
    };
    onDependencyMiss?: () => void;
    dependencies?: object;
    externals?: Record<string, string>;
    context?: LowcodeContext;
}): Promise<LowcodeContext>;
export declare function cleanLowcodeContext(): void;
